#!/usr/bin/perl
########################################################################
# File:           rootfiles/secnfsaccount.pl                           #
# myLinux Server: Copyright (c) 2004 Michael Oberg                     #
# Version:        0.98                                                 #
# Author:         Michael Oberg <michael.oberg@mylinuxproject.de>      #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License as published by #
# the Free Software Foundation; either version 2 of the License, or    #
# (at your option) any later version.                                  #
#                                                                      #
# This program is distributed in the hope that it will be useful,      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         #
# GNU General Public License for more details.                         #
#                                                                      #
# You should have received a copy of the GNU Public License along      #
# with this package; if not, write to the Free Software Foundation,    #
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.       #
########################################################################

use mylinux::env;
use mylinux::usermanager;

print "This program creates a trust account for Secure NFS.\n";
print "Use it with care. The file /usr/etc/snfs/home/.ssh/id_rsa\n";
print "makes it possible to log in this account on the server\n";
print "without using a password.\n";
print "The file MUST NOT be compromised by anyone!\n\n";

print "Remote machine name or IP address: ";
$MACHINENAME = <STDIN>;
chomp $MACHINENAME;
if (!$MACHINENAME) {
  die ("You have to specify the machine name!\n");
}

&usermanager::ssh_trustaccount ("snfs", $MACHINENAME, "snfs");

system ("su snfs -c \"scp $MACHINENAME:/etc/exports /usr/etc/snfs/home/$MACHINENAME.exports\"");

$TMPMID = `cat $env::DATAPATH/mcounter`;
chomp $TMPMID;
$NEWMID = $TMPMID + 1;
$TMPOUT = `echo $NEWMID > $env::DATAPATH/mcounter`;

$NEWPROG = $NEWMID+50000;

if (system ("cat /usr/etc/snfs/home/$MACHINENAME.exports | grep '^[ \\t]*/[ \\t][ \\t]*127\\.0\\.0\\.1' > /dev/null") == 0) {
  mkdir "/mnt/$MACHINENAME";
  $FSTAB = `grep -v /mnt/$MACHINENAME /etc/fstab`;
  $FSTAB .= "$env::fqhostname:/	/mnt/$MACHINENAME	nfs	user,noauto,hard,intr,rsize=8192,wsize=8192,mountprog=$NEWMID,nfsprog=$NEWPROG	0	0";
  open (FT, "> /etc/fstab");
  print FT $FSTAB;
  close FT;
}
$IMPORTMOUNTPOINTS = `cat /usr/etc/snfs/home/$MACHINENAME.exports | grep '/mnt.*127\\.0\\.0\\.1' | sed 's\@.*/mnt/\\([^ \\t]*\\).*\@\\1\@'`;
foreach $mp (split /\n/, $IMPORTMOUNTPOINTS) {
  mkdir "/mnt/$MACHINENAME.$mp";
  $FSTAB = `grep -v /mnt/$MACHINENAME.$mp /etc/fstab`;
  $FSTAB .= "$env::fqhostname:/mnt/$mp	/mnt/$MACHINENAME.$mp	nfs	user,noauto,hard,intr,rsize=8192,wsize=8192,mountprog=$NEWMID,nfsprog=$NEWPROG	0	0\n";
  open (FT, "> /etc/fstab");
  print FT $FSTAB;
  close FT;
}

system ("snfshost $MACHINENAME:$NEWMID");
system ("smkdirall");
