#!/bin/sh
########################################################################
# File:           setup/ldap-server.sh                                 #
# myLinux Server: Copyright (c) 2004 Michael Oberg                     #
# Version:        0.98                                                 #
# Author:         Michael Oberg <michael.oberg@mylinuxproject.de>      #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License as published by #
# the Free Software Foundation; either version 2 of the License, or    #
# (at your option) any later version.                                  #
#                                                                      #
# This program is distributed in the hope that it will be useful,      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         #
# GNU General Public License for more details.                         #
#                                                                      #
# You should have received a copy of the GNU Public License along      #
# with this package; if not, write to the Free Software Foundation,    #
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.       #
########################################################################
source mylinux.conf
TOPDOMAIN=`echo $DOMAIN | sed 's/.*\.\([^.]*\)$/\1/'`
SUBDOMAIN=`echo $DOMAIN | sed 's/\(.*\)\.[^.]*$/\1/'`
BASEDN="dc=$SUBDOMAIN,dc=$TOPDOMAIN"

cat << EOF > /etc/webmin/ldap-useradmin/config
given=1
imap_login=root
samba_class=sambaAccount
auth_ldap=/etc/ldap.conf
imap_folders=old public sent-mail
md5=1
imap_class=SuSEeMailObject
quota=
addressbook=$BASEDN
user_base=ou=users,$BASEDN
domain=
other_class=
ldap_host=$LDAPHOST
ldap_port=
imap_host=
pass=$LDAPPASSWD
samba_domain=
group_base=ou=groups,$BASEDN
login=cn=admin,$BASEDN
samba_props=
imap_props=
props=
fields=
imap_pass=
EOF

CATOP=/etc/ssl/mylinux
YEAR=`date +%Y`

echo create Webmin certificate
mkdir /etc/webmin
cat << EOF | openssl req -nodes -new -days 365 -keyout /etc/webmin/miniserv.key -out /etc/webmin/req.pem 2> /dev/null
$COUNTRY
$STATE
$CITY
$COMPANY
Webmin $YEAR
$FQHOSTNAME
root@$DOMAIN


EOF
cat << EOF | openssl ca -policy policy_anything -out /etc/webmin/miniserv.pem -infiles /etc/webmin/req.pem 2> /dev/null
y
y
EOF
chmod 600 /etc/webmin/*.pem /etc/webmin/miniserv.key

if grep certfile /etc/webmin/miniserv.conf > /dev/null
then
  cat /etc/webmin/miniserv.conf | \
    sed -e 's@keyfile=.*@keyfile=/etc/webmin/miniserv.key@' \
        -e 's@certfile=.*@certfile=/etc/webmin/miniserv.pem@' \
    > /etc/webmin/miniserv.conf-new
  mv /etc/webmin/miniserv.conf-new /etc/webmin/miniserv.conf
else
  cat /etc/webmin/miniserv.conf | \
    sed 's@keyfile=.*@keyfile=/etc/webmin/miniserv.key@' \
    > /etc/webmin/miniserv.conf-new
  mv /etc/webmin/miniserv.conf-new /etc/webmin/miniserv.conf
  echo "certfile=/etc/webmin/miniserv.pem" >> /etc/webmin/miniserv.conf
fi
