#!/bin/sh
########################################################################
# File:           setup/apache.sh                                      #
# myLinux Server: Copyright (c) 2004 Michael Oberg                     #
# Version:        0.97                                                 #
# Author:         Michael Oberg <michael.oberg@mylinuxproject.de>      #
#                                                                      #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License as published by #
# the Free Software Foundation; either version 2 of the License, or    #
# (at your option) any later version.                                  #
#                                                                      #
# This program is distributed in the hope that it will be useful,      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         #
# GNU General Public License for more details.                         #
#                                                                      #
# You should have received a copy of the GNU Public License along      #
# with this package; if not, write to the Free Software Foundation,    #
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.       #
########################################################################
source ./mylinux.conf
##############################################################
# configure Squid proxy server                               #
##############################################################
if [ x$IF0_ADDR = x ]
then
  SUBNET=127.0.0
else
  SUBNET=$IF0_SUBNET
fi

if `echo $SUBNET | grep '[0-9]*\.[0-9]*\.[0-9]*' > /dev/null`
then
  SUBNET_FULL="$SUBNET.0"
elif `echo $SUBNET | grep '[0-9]*\.[0-9]*' > /dev/null`
then
  SUBNET_FULL="$SUBNET.0.0"
else
  SUBNET_FULL="$SUBNET.0.0.0"
fi

cat /etc/squid.conf-template | \
  sed -e "s/client_netmask 255.255.255.0/client_netmask $IF0_MASK/" \
      -e "s/ftp_user root@mylinux.de/ftp_user root@$DOMAIN/" \
      -e "s/acl our_networks src 192.168.0.0\/255.255.255.0/acl our_networks src $SUBNET_FULL\/$IF0_MASK/" \
  > /etc/squid.conf
